{ 000115-4.PAS                                                              }
{ 2000-01-15 programmeerimisolmpiaadi 4. lesande lahendus                 }
{    MADU                                                                   }
{ Testitud: TP 7.0, FPC 0.99.10                                             }
{ Oleg Mrk                                                                 }

{$i+}{$r-}{$q-}{$s+}
uses crt;
const
 MAX_SIZE = 40;
 MAX_X = 40;
 MAX_Y = 20;

 IMPOSSIBLE = -1;

 EMPTY = 0;
 WALL = 1;
 CARROT = 2;

 NOT_VISITED = -1;

 INPUT_FILE = 'madu.sis';
 OUTPUT_FILE = 'madu.val';

 BAD_INPUT_STR = 'Bad input!';
 NO_SOLUTION_STR = 'No solution!';

type
 map = array[1..MAX_SIZE,1..MAX_SIZE] of integer;
 list = array[1..MAX_SIZE*MAX_SIZE] of char;

var
 m,n:integer;
 cave:map;

 visited:map;
 carrot_n:integer;

 path_start_x:integer;
 path_start_y:integer;
 path_len:integer;
 path:list;

 sol_found:boolean;
 sol_start_x:integer;
 sol_start_y:integer;
 sol_len:integer;
 solution:list;

procedure raiseError(message:String);
begin
 writeln('Fatal error:', message);
 halt(0);
end;

procedure write_map(var mp:map);
var y,x:integer;
begin
 writeln;
 for y:=1 to n do
 begin
  for x:=1 to m do write(mp[x,y]:3);
  writeln;
 end;
end;

function read_cave(x,y:integer):integer;
begin
 read_cave:=WALL;
 if (x < 1) or (x > m) or
    (y < 1) or (y > n) then exit;
 read_cave:=cave[x,y];
end;

function read_visited(x,y:integer):integer;
begin
 read_visited:=NOT_VISITED;
 if (x < 1) or (x > m) or
    (y < 1) or (y > n) then exit;
 read_visited:=visited[x,y];
end;

function on_edge(x,y:integer):boolean;
begin
 on_edge:=(x=1) or (x=m) or (y=1)or(y=n);
end;

procedure search(x,y,d,prev_x,prev_y:integer);
function cut(cx,cy:integer):boolean;
begin
 cut:=(read_visited(cx,cy) = d) and not((cx=prev_x)and(cy=prev_y));
end;

begin
{ clrscr;
 write_map(cave);
 write_map(visited);}


 if sol_found then exit;

 if read_cave(x,y)=WALL then exit;
 if read_visited(x,y)<>NOT_VISITED then exit;

 if cut(x-1,y) or cut(x+1,y) or
    cut(x,y-1) or cut(x,y+1) then exit;

 if read_cave(x,y)=CARROT then inc(d);

 if (d = carrot_n) and (on_edge(x,y)) then
 begin
  if not(sol_found) or (path_len < sol_len) then
  begin
   sol_found:=true;
   sol_len:=path_len;
   sol_start_x:=path_start_x;
   sol_start_y:=path_start_y;
   move(path,solution,sizeof(list));
  end;
  exit;
 end;

 inc(path_len);
 visited[x,y]:=d;

 path[path_len]:='N';
 search(x,y-1,d,x,y);

 path[path_len]:='S';
 search(x,y+1,d,x,y);

 path[path_len]:='E';
 search(x+1,y,d,x,y);

 path[path_len]:='W';
 search(x-1,y,d,x,y);

 visited[x,y]:=NOT_VISITED;
 dec(path_len);
end;

procedure solve;
var
 x,y:integer;
begin
 carrot_n:=0;

 for x:=1 to m do
  for y:=1 to n do
  begin
   visited[x,y]:=NOT_VISITED;
   if cave[x,y]=CARROT then inc(carrot_n);
  end;

 sol_found:=false;

 for x:=1 to m do
 begin
   path_start_x:=x;
   path_start_y:=1;
   search(x,1,0,IMPOSSIBLE,IMPOSSIBLE);
   path_start_x:=x;
   path_start_y:=n;
   search(x,n,0,IMPOSSIBLE,IMPOSSIBLE);
 end;

 for y:=1 to n do
 begin
   path_start_x:=1;
   path_start_y:=y;
   search(1,y,0,IMPOSSIBLE,IMPOSSIBLE);
   path_start_x:=m;
   path_start_y:=y;
   search(m,y,0,IMPOSSIBLE,IMPOSSIBLE);
 end;
end;

procedure read_data;
var
 f:text;
 ch:char;
 x,y:integer;
begin
 assign(f,INPUT_FILE);
 reset(f);
 readln(f,m,n);
 if (m < 3) or (n < 3) or
    (m > MAX_X) or (n > MAX_Y) then raiseError(BAD_INPUT_STR);

 for y:=1 to n do
 begin
  for x:=1 to m do
  begin
   read(f,ch);
   case ch of
    '#':cave[x,y]:=WALL;
    '!':cave[x,y]:=CARROT;
    '.':cave[x,y]:=EMPTY;
   else
    raiseError(BAD_INPUT_STR);
   end;
  end;
  readln(f);
 end;

 close(f);
end;

procedure write_data;
var
 f:text;
 l:integer;
begin
 assign(f,OUTPUT_FILE);
 rewrite(f);

 if not sol_found then writeln(f, NO_SOLUTION_STR)
 else
 begin
  writeln(f, sol_start_x, ' ', 1+n-sol_start_y);
  for l:=1 to sol_len do write(f,solution[l]);
 end;

 close(f);
end;

begin
 read_data;
 solve;
 write_data;
end.
